/* . . . . . . BEGIN . . . . . . . . . . . . */
extern double ProperDistance( double z, double H0, double q0 );

extern double CosmicAngle( double sep, double z, double H0, double q0 );

extern double CosmicSeparation( double theta, double z, double H0, double q0 );

extern void read_raw6_photon( unsigned char raw6_bytes[5], short *X, short *Y );

extern double gaussian_sig( double x );

extern double gaussian_hwhm( double x );

extern double gaussval( double x, double FWHM );

extern float math_random_x( int np, float xx[], float aa[] );

extern void math_load_GAA( GAAtype GAA[] );

extern void math_gaussian_area_array( int *np, float xx[], float aa[] );

extern double math_gaussian_area_sigma( double x1, double x2, double xinc);

extern double math_gaussian_volume_hwhm( double r1, double r2, double hwhm );

extern double math_gaussian_volume_sigma( double r1, double r2, double sigma );

extern void xyz2radec(double x, double y, double z, double *ra, double *dec);

extern void radec2xyz(double ra, double dec, double *x, double *y, double *z);

extern void radec2ypzp(double ra, double dec, double RM[3][3],
                 double *yp, double *zp );

extern void radec2prime(double ra, double dec, RMtype RM, double *xp, double *yp, double *zp );

extern void prime2detector( int bandnumber, double aspp, double xp, double yp, double zp, double RotMat[2][2], double *det_x, double *det_y );

extern void detector2prime( int bandnumber, double aspp, double det_x, double det_y, double RotMatInv[2][2],
                     double *xp, double *yp, double *zp );

extern void detector2spacecraft( int bandnumber, double det_x, double det_y, double *scx, double *scy );

extern void spacecraft2flatfield( double scx, double scy, double *flatx, double *flaty );

extern void matrix_radec2prime(double ra, double dec, double RM[3][3], double *rap, double *decp );

extern void xyz2prime(double x, double y, double z, double RM[3][3],
               double *xp, double *yp, double *zp);

extern void prime2xyz(double xp, double yp, double zp, double RMinv[3][3],
               double *x, double *y, double *z);

extern void prime2radec( double xp, double yp, double zp, RMtype RM, double *ra, double *dec );

extern void MatMul3D(double aa[3][3], double bb[3][3], double cc[3][3] );

extern double MatDet2D(double aa[2][2]);

extern double MatSubDet3D(int col, int row, double aa[3][3]);

extern double MatDet3D(double aa[3][3]);

extern double MatCof3D(int col, int row, double aa[3][3]);

extern void MatInv3D(double mm[3][3], double mminv[3][3] );

extern void MatInv2D(double mm[2][2], double mminv[2][2] );

extern void SetRotationMatrix( double alpha, double theta, RMtype RM[1] );

extern void SetImageRotationMatrix( double PA, RMtype RM[] );

extern void SetRotMat2D( double Angle, double RotMat[2][2], double RotMatInv[2][2] );

extern double camotry( double pp[AmoebaMax][AmoebaMax], double y[],
                double psum[], int ndim,
                double (*funk)(double []), int ihi, double fac );

extern void camoeba( double pp[AmoebaMax][AmoebaMax], double y[], int ndim,
              double ftol, double (*funk)(double []), int *nfunk );

extern void camoeba_gate( double (*funk)(double []),
                   int npar, double par[], double parsl[],
                   double ftol, double *resid, int *niter );

extern void fit_straight_line( int nn, double xx[], double yy[], double ww[], double coef[] );

extern void math_fit_gaussian( int nn, double x8[], double y8[], double w8[], double *peak, double *hwhm );

extern void math_fit_power_law( int nn, double x8[], double y8[], double w8[], double *aa, double *bb );

extern void GJ_gaussj( const int np, double a[np][np], int n, double b[] );

extern void GJ_covsrt( const int ncvm, int ma, int mfit,
                double covar[ncvm][ncvm], int lista[] );

extern void GJ_polyfuncs( int np, double x, double p[] );

extern void GJ_lfit( int ndata, int ma, const int ncvm,
              double x[], double y[], double sig[],
              double a[], int lista[], int mfit,
              double covar[ncvm][ncvm], double *chisq );

extern void GJ_polyfit_residuals( int npt, double x[], double y[], double wt[],
                           int order, double xoff, double coef[],
                           double *high, double *wrms, double *wppd );

extern int GJ_polyfit( int npt, double x[], double y[], double wt[], int order,
                int forcexoff, double *xoff, double ucoef[] );

extern int GJ_polyfit_inverse( int order, double coef[], double xoff, double x1, double x2,
                        int iorder, double icoef[], double *ixoff, double *high );

extern void math_convolve_gaussian( int nn, double xx[], double aa[], double fwhm,
                             double cutoff, double aac[] );

extern void math_convolve_gaussian0( int nn, double xx[], double aa[], double fwhm,
                              double cutoff, double aac[] );

extern void math_smooth_image_gauss_wgt( double hwhm, double image[], double swgt[], int nc, int nr, double minv, double maxv, double result[] );

extern void math_smooth_image_gauss( double hwhm, double image[], int nc, int nr, double minv, double maxv, double result[] );

extern int pop_galeqd(double xl,double xb,double *rad,double *decd);

extern int pop_equgad(double rad,double decd,double *xl,double *xb);

/* . . . . . . END . . . . . . . . . . . . . */
